#include <bits/stdc++.h>
using namespace std;


typedef long long ll;

const int VMAX = 100005;
const int INF = -1;

int n;
ll sum[4 * VMAX];
int a, b;

void Build(int x, int l, int r)
{
    if (l == r)
    {
        cin >> sum[x];
        return;
	}

	int m = (l + r) / 2;
	Build(2 * x, l, m);
	Build(2 * x + 1, m + 1, r);
	sum[x] = sum[2 * x] + sum[2 * x + 1];
}

ll Query(int x, int l, int r)
{
    if (a <= l && r <= b)
        return sum[x];

    int m = (l + r) / 2;
    ll s = 0;
    if (a <= m)
        s = Query(2 * x, l, m);
    if (b > m)
		s += Query(2 * x + 1, m + 1, r);
    return s;
}

void Update(int x, int l, int r, int i, int v)
{
    if (l == r)
    {
        sum[x] = v;
        return;
    }

	int m = (l + r) / 2;
	if (i <= m)
		Update(2 * x, l, m, i, v);
	else
		Update(2 * x + 1, m + 1, r, i, v);

	sum[x] = sum[2 * x] + sum[2 * x + 1];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

	int q;
	cin >> n >> q;

    Build(1, 1, n);

    for (int i = 0; i < q; ++i)
    {
        int op;
        cin >> op >> a >> b;
        if (op == 1)
            Update(1, 1, n, a, b);
        else
            cout << Query(1, 1, n) << '\n';
    }

    return 0;
}
